﻿Imports Data.Tsql
Imports System.Globalization

Public NotInheritable Class Field

#Region " Declarations "
    Private Sub New()

    End Sub
#End Region

#Region " Methods "
    Public Overloads Shared Function GetQuotedFieldName(ByVal strFieldName As String) As String
        Return GetQuotedFieldName(strFieldName, String.Empty, Keyword.OpenQuote, Keyword.CloseQuote)
    End Function

    Public Overloads Shared Function GetQuotedFieldName(ByVal strFieldName As String, ByVal strPrefix As String) As String
        Return GetQuotedFieldName(strFieldName, strPrefix, Keyword.OpenQuote, Keyword.CloseQuote)
    End Function

    Public Overloads Shared Function GetQuotedFieldName(ByVal strFieldName As String, ByVal strPrefix As String, ByVal chrOpenQuote As Char, ByVal chrCloseQuote As Char) As String
        If IsNothing(strFieldName) Then
            Throw New ArgumentNullException("strFieldName")
        End If

        If (strFieldName.StartsWith(chrOpenQuote) And strFieldName.EndsWith(chrCloseQuote)) Then
            If (strPrefix = String.Empty) Then
                Return strFieldName
            Else
                Return strFieldName.Insert(1, strPrefix)
            End If
        Else
            Return String.Format("{0}{2}{3}{1}", chrOpenQuote, chrCloseQuote, strPrefix, strFieldName)
        End If

    End Function

    Public Overloads Shared Function GetFieldName(ByVal strFieldName As String) As String
        If IsNothing(strFieldName) Then
            Throw New ArgumentNullException("strFieldName")
        End If

        If (strFieldName.StartsWith(Keyword.OpenQuote) _
            And strFieldName.EndsWith(Keyword.CloseQuote)) _
        Then
            Return strFieldName.Substring(1, strFieldName.Length - 2)
        Else
            Return strFieldName
        End If

    End Function

    Public Overloads Shared Function GetFieldName(ByVal strFieldName As String, ByVal strPrefix As String) As String
        If IsNothing(strFieldName) Then
            Throw New ArgumentNullException("strFieldName")
        End If

        If (strFieldName.StartsWith(Keyword.OpenQuote) _
            And strFieldName.EndsWith(Keyword.CloseQuote)) _
        Then
            Return strPrefix + strFieldName.Substring(1, strFieldName.Length - 2)
        Else
            Return strPrefix + strFieldName
        End If

    End Function

    Public Shared Function GetSqlAliasString(ByVal strFieldName As String, ByVal strAlias As String) As String
        Return String.Concat(GetQuotedFieldName(strFieldName), Keyword.As, GetQuotedFieldName(strAlias))
    End Function
#End Region

End Class

