﻿#Region " Imports "
Imports Infragistics.Web.UI.GridControls

#End Region
<Serializable()>
Public Class GridGroupedColumn
    Private _column As String
    Private _sortDirection As String
#Region " Declaration "
    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub New(ByVal strColumn As String)
        If (strColumn.EndsWith(" (ascending)")) Then
            Me._column = Field.GetFieldName(strColumn.Substring(0, strColumn.Length - 12))
            Me._sortDirection = [Enum].GetName(GetType(Infragistics.Web.UI.GridControls.GroupingSortDirection), Infragistics.Web.UI.GridControls.GroupingSortDirection.Ascending)
        ElseIf (strColumn.EndsWith(" ASC")) Then
            Me._column = Field.GetFieldName(strColumn.Substring(0, strColumn.Length - 4))
            Me._sortDirection = [Enum].GetName(GetType(Infragistics.Web.UI.GridControls.GroupingSortDirection), Infragistics.Web.UI.GridControls.GroupingSortDirection.Ascending)
        ElseIf (strColumn.EndsWith(" ASCENDING")) Then
            Me._column = Field.GetFieldName(strColumn.Substring(0, strColumn.Length - 10))
            Me._sortDirection = [Enum].GetName(GetType(Infragistics.Web.UI.GridControls.GroupingSortDirection), Infragistics.Web.UI.GridControls.GroupingSortDirection.Ascending)
        ElseIf (strColumn.EndsWith(" (descending)")) Then
            Me._column = Field.GetFieldName(strColumn.Substring(0, strColumn.Length - 13))
            Me._sortDirection = [Enum].GetName(GetType(Infragistics.Web.UI.GridControls.GroupingSortDirection), Infragistics.Web.UI.GridControls.GroupingSortDirection.Descending)
        ElseIf (strColumn.EndsWith(" DESC")) Then
            Me._column = Field.GetFieldName(strColumn.Substring(0, strColumn.Length - 5))
            Me._sortDirection = [Enum].GetName(GetType(Infragistics.Web.UI.GridControls.GroupingSortDirection), Infragistics.Web.UI.GridControls.GroupingSortDirection.Descending)
        ElseIf (strColumn.EndsWith(" DESCENDING")) Then
            Me._column = Field.GetFieldName(strColumn.Substring(0, strColumn.Length - 11))
            Me._sortDirection = [Enum].GetName(GetType(Infragistics.Web.UI.GridControls.GroupingSortDirection), Infragistics.Web.UI.GridControls.GroupingSortDirection.Descending)
        Else
            Me._column = Field.GetFieldName(strColumn)
            Me._sortDirection = [Enum].GetName(GetType(Infragistics.Web.UI.GridControls.GroupingSortDirection), Infragistics.Web.UI.GridControls.GroupingSortDirection.Ascending)
        End If
    End Sub

    Public Sub New(ByVal column As GroupedColumn)
        Me._column = column.ColumnKey
        Me._sortDirection = [Enum].GetName(GetType(Infragistics.Web.UI.GridControls.GroupingSortDirection), column.SortDirection)
    End Sub
#End Region

#Region " Properties "
    Public Property Column() As String
        Get
            Return Me._column
        End Get
        Set(value As String)
            Me._column = value
        End Set
    End Property

    Public Property SortDirection() As String
        Get
            Return Me._sortDirection
        End Get
        Set(value As String)
            Me._sortDirection = value
        End Set
    End Property
#End Region
End Class
